// SPDX-License-Identifier: GPL-3.0
pragma solidity ^0.8.23;

import { Ownable } from "@openzeppelin/contracts/access/Ownable.sol";
import { DCO2s } from "./DCO2s.sol";

contract AA is Ownable {
    DCO2s public dco2sc;
    string[] nfts; 

    mapping (address => bool) public airdropped;
    address[] public allowed;

    constructor(string memory name,
                string memory symbol,
                string memory baseURI,
                string [] memory nftURIs
               ) Ownable(msg.sender) {
        dco2sc = new DCO2s(address(this),address(this), baseURI, name, symbol); 
        nfts = nftURIs;
    }

    // Auction Logic
    // modifier to start and finish auction
    // ToDo Check blockchain bid example
    // function bid and lock tokens
    // function cashback

    // Mint Function
    // Simplify
    function _mint(address to, string memory uri) public onlyOwner {
        dco2sc.safeMint(to, uri);
    }

    // @notice Random giveaway function
    function airdrop() public {    
        //require(eligible(msg.sender));
        require(!airdropped[msg.sender], "address already airdropped");
        // top 20 is for Auction
        uint256 randomURI = getRandomNumber() % nfts.length - 20;
        dco2sc.safeMint(msg.sender, nfts[randomURI]);
        // Require remove the URI so that is not mintable again
        airdropped[msg.sender] = true;

    }

    // @eligible
    function eligible(address to) public view returns (bool winner) {
        // require( callable until specific date)
        // Activity
        // Longest Holders
        // Top Holders
        // or Allowed Wallets()
    }

    // @notice allowed addresses that supports DECA
    function allow(address supporter) public onlyOwner {
        //require(eligible(supporter));
        require(!airdropped[supporter], "address already airdropped");
        allowed.push(supporter);
    }
    

    // @notice Returns a randon number calculated from previews block randao
    // @dev This only works after the merge
    function getRandomNumber() public view returns (uint randomNumber) {
        randomNumber = block.prevrandao;
    }

}


